From patchwork Mon Nov 14 12:48:47 2022
Content-Type: text/plain; charset="utf-8"
MIME-Version: 1.0
Content-Transfer-Encoding: 7bit
X-Patchwork-Submitter: Jason Yan <yanaijie@huawei.com>
X-Patchwork-Id: 183115
Return-Path: <yanaijie@huawei.com>
Received: from dggems704-chm.china.huawei.com (10.3.19.181) by
 dggems702-chm.china.huawei.com (10.3.19.179) with Microsoft SMTP Server
 (version=TLS1_2, cipher=TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256) id
 15.1.2375.31 via Mailbox Transport; Mon, 14 Nov 2022 20:32:19 +0800
Received: from canpemm500004.china.huawei.com (7.192.104.92) by
 dggems704-chm.china.huawei.com (10.3.19.181) with Microsoft SMTP Server
 (version=TLS1_2, cipher=TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256) id
 15.1.2375.31; Mon, 14 Nov 2022 20:32:19 +0800
Received: from huawei.com (10.175.127.227) by canpemm500004.china.huawei.com
 (7.192.104.92) with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256) id 15.1.2375.31; Mon, 14 Nov
 2022 20:32:19 +0800
From: Jason Yan <yanaijie@huawei.com>
To: <yanaijie@huawei.com>, <zhengzengkai@huawei.com>, <xiexiuqi@huawei.com>,
	<yi.zhang@huawei.com>, <patchwork@huawei.com>, <kernel.openeuler@huawei.com>,
	<houtao1@huawei.com>
Subject: [PATCH OLK-5.10 v2 018/308] cifsd: remove unneeded macros
Date: Mon, 14 Nov 2022 20:48:47 +0800
Message-ID: <20221114125337.1831594-19-yanaijie@huawei.com>
X-Mailer: git-send-email 2.31.1
In-Reply-To: <20221114125337.1831594-1-yanaijie@huawei.com>
References: <20221114125337.1831594-1-yanaijie@huawei.com>
Content-Type: text/plain
X-MS-Exchange-Organization-Network-Message-Id: 
 91ef09b4-fbe2-459a-2dcf-08dac63c45b0
X-MS-Exchange-Organization-AuthSource: canpemm500004.china.huawei.com
X-MS-Exchange-Organization-AuthAs: Internal
X-MS-Exchange-Organization-AuthMechanism: 07
X-Originating-IP: [10.175.127.227]
X-ClientProxiedBy: dggems702-chm.china.huawei.com (10.3.19.179) To
 canpemm500004.china.huawei.com (7.192.104.92)
X-MS-Exchange-Transport-EndToEndLatency: 00:00:00.7053408
X-MS-Exchange-Processed-By-BccFoldering: 15.01.2375.031
MIME-Version: 1.0

From: Namjae Jeon <namjae.jeon@samsung.com>

mainline inclusion
from mainline-5.15-rc1
commit e5066499079de0e1dac094baf4cb62eb86cbdd4f
category: feature
bugzilla: https://gitee.com/openeuler/kernel/issues/I60T7G
CVE: NA

Reference: https://git.kernel.org/torvalds/linux/c/e5066499079d

-------------------------------

Remove unneeded RESPONSE_BUF, REQUEST_BUF, RESPONSE_SZ, INIT_AUX_PAYLOAD,
HAS_AUX_PAYLOAD, AUX_PAYLOAD, AUX_PAYLOAD_SIZE, RESP_HDR_SIZE,
HAS_TRANSFORM_BUF and TRANSFORM_BUF macros.

Signed-off-by: Namjae Jeon <namjae.jeon@samsung.com>
Signed-off-by: Steve French <stfrench@microsoft.com>
Signed-off-by: Jason Yan <yanaijie@huawei.com>
---
 fs/cifsd/connection.c |  15 ++-
 fs/cifsd/ksmbd_work.c |  12 +--
 fs/cifsd/ksmbd_work.h |  24 +----
 fs/cifsd/oplock.c     |  14 +--
 fs/cifsd/server.c     |   4 +-
 fs/cifsd/smb2misc.c   |   2 +-
 fs/cifsd/smb2pdu.c    | 212 +++++++++++++++++++++---------------------
 fs/cifsd/smb_common.c |   8 +-
 fs/cifsd/vfs.c        |   2 +-
 9 files changed, 139 insertions(+), 154 deletions(-)

diff --git a/fs/cifsd/connection.c b/fs/cifsd/connection.c
index d27553dee2ad..bdfde5ca2ded 100644
--- a/fs/cifsd/connection.c
+++ b/fs/cifsd/connection.c
@@ -154,7 +154,7 @@ void ksmbd_conn_wait_idle(struct ksmbd_conn *conn)
 int ksmbd_conn_write(struct ksmbd_work *work)
 {
 	struct ksmbd_conn *conn = work->conn;
-	struct smb_hdr *rsp_hdr = RESPONSE_BUF(work);
+	struct smb_hdr *rsp_hdr = work->response_buf;
 	size_t len = 0;
 	int sent;
 	struct kvec iov[3];
@@ -166,21 +166,20 @@ int ksmbd_conn_write(struct ksmbd_work *work)
 		return -EINVAL;
 	}
 
-	if (HAS_TRANSFORM_BUF(work)) {
+	if (work->tr_buf) {
 		iov[iov_idx] = (struct kvec) { work->tr_buf,
 				sizeof(struct smb2_transform_hdr) };
 		len += iov[iov_idx++].iov_len;
 	}
 
-	if (HAS_AUX_PAYLOAD(work)) {
-		iov[iov_idx] = (struct kvec) { rsp_hdr, RESP_HDR_SIZE(work) };
+	if (work->aux_payload_sz) {
+		iov[iov_idx] = (struct kvec) { rsp_hdr, work->resp_hdr_sz };
 		len += iov[iov_idx++].iov_len;
-		iov[iov_idx] = (struct kvec) { AUX_PAYLOAD(work),
-			AUX_PAYLOAD_SIZE(work) };
+		iov[iov_idx] = (struct kvec) { work->aux_payload_buf, work->aux_payload_sz };
 		len += iov[iov_idx++].iov_len;
 	} else {
-		if (HAS_TRANSFORM_BUF(work))
-			iov[iov_idx].iov_len = RESP_HDR_SIZE(work);
+		if (work->tr_buf)
+			iov[iov_idx].iov_len = work->resp_hdr_sz;
 		else
 			iov[iov_idx].iov_len = get_rfc1002_len(rsp_hdr) + 4;
 		iov[iov_idx].iov_base = rsp_hdr;
diff --git a/fs/cifsd/ksmbd_work.c b/fs/cifsd/ksmbd_work.c
index 8cd5dff0762d..505e59df3071 100644
--- a/fs/cifsd/ksmbd_work.c
+++ b/fs/cifsd/ksmbd_work.c
@@ -40,18 +40,18 @@ void ksmbd_free_work_struct(struct ksmbd_work *work)
 	WARN_ON(work->saved_cred != NULL);
 	if (server_conf.flags & KSMBD_GLOBAL_FLAG_CACHE_TBUF &&
 			work->set_trans_buf)
-		ksmbd_release_buffer(RESPONSE_BUF(work));
+		ksmbd_release_buffer(work->response_buf);
 	else
-		ksmbd_free_response(RESPONSE_BUF(work));
+		ksmbd_free_response(work->response_buf);
 
 	if (server_conf.flags & KSMBD_GLOBAL_FLAG_CACHE_RBUF &&
 			work->set_read_buf)
-		ksmbd_release_buffer(AUX_PAYLOAD(work));
+		ksmbd_release_buffer(work->aux_payload_buf);
 	else
-		ksmbd_free_response(AUX_PAYLOAD(work));
+		ksmbd_free_response(work->aux_payload_buf);
 
-	ksmbd_free_response(TRANSFORM_BUF(work));
-	ksmbd_free_request(REQUEST_BUF(work));
+	ksmbd_free_response(work->tr_buf);
+	ksmbd_free_request(work->request_buf);
 	if (work->async_id)
 		ksmbd_release_id(work->conn->async_ida, work->async_id);
 	kmem_cache_free(work_cache, work);
diff --git a/fs/cifsd/ksmbd_work.h b/fs/cifsd/ksmbd_work.h
index 405434d4c8ab..28a1692ed37f 100644
--- a/fs/cifsd/ksmbd_work.h
+++ b/fs/cifsd/ksmbd_work.h
@@ -27,12 +27,12 @@ struct ksmbd_work {
 	struct ksmbd_tree_connect       *tcon;
 
 	/* Pointer to received SMB header */
-	char                            *request_buf;
+	void                            *request_buf;
 	/* Response buffer */
-	char                            *response_buf;
+	void                            *response_buf;
 
 	/* Read data buffer */
-	char                            *aux_payload_buf;
+	void                            *aux_payload_buf;
 
 	/* Next cmd hdr in compound req buf*/
 	int                             next_smb2_rcv_hdr_off;
@@ -92,24 +92,10 @@ struct ksmbd_work {
 #define WORK_CLOSED(w)		((w)->state == KSMBD_WORK_CLOSED)
 #define WORK_ACTIVE(w)		((w)->state == KSMBD_WORK_ACTIVE)
 
-#define RESPONSE_BUF(w)		((void *)(w)->response_buf)
-#define REQUEST_BUF(w)		((void *)(w)->request_buf)
-
 #define RESPONSE_BUF_NEXT(w)	\
-	((void *)((w)->response_buf + (w)->next_smb2_rsp_hdr_off))
+	(((w)->response_buf + (w)->next_smb2_rsp_hdr_off))
 #define REQUEST_BUF_NEXT(w)	\
-	((void *)((w)->request_buf + (w)->next_smb2_rcv_hdr_off))
-
-#define RESPONSE_SZ(w)		((w)->response_sz)
-
-#define INIT_AUX_PAYLOAD(w)	((w)->aux_payload_buf = NULL)
-#define HAS_AUX_PAYLOAD(w)	((w)->aux_payload_sz != 0)
-#define AUX_PAYLOAD(w)		((void *)((w)->aux_payload_buf))
-#define AUX_PAYLOAD_SIZE(w)	((w)->aux_payload_sz)
-#define RESP_HDR_SIZE(w)	((w)->resp_hdr_sz)
-
-#define HAS_TRANSFORM_BUF(w)	((w)->tr_buf != NULL)
-#define TRANSFORM_BUF(w)	((void *)((w)->tr_buf))
+	(((w)->request_buf + (w)->next_smb2_rcv_hdr_off))
 
 struct ksmbd_work *ksmbd_alloc_work_struct(void);
 void ksmbd_free_work_struct(struct ksmbd_work *work);
diff --git a/fs/cifsd/oplock.c b/fs/cifsd/oplock.c
index e56c938a8f7a..25823bb7d086 100644
--- a/fs/cifsd/oplock.c
+++ b/fs/cifsd/oplock.c
@@ -608,14 +608,14 @@ static inline int allocate_oplock_break_buf(struct ksmbd_work *work)
  * There are two ways this function can be called. 1- while file open we break
  * from exclusive/batch lock to levelII oplock and 2- while file write/truncate
  * we break from levelII oplock no oplock.
- * REQUEST_BUF(work) contains oplock_info.
+ * work->request_buf contains oplock_info.
  */
 static void __smb2_oplock_break_noti(struct work_struct *wk)
 {
 	struct smb2_oplock_break *rsp = NULL;
 	struct ksmbd_work *work = container_of(wk, struct ksmbd_work, work);
 	struct ksmbd_conn *conn = work->conn;
-	struct oplock_break_info *br_info = REQUEST_BUF(work);
+	struct oplock_break_info *br_info = work->request_buf;
 	struct smb2_hdr *rsp_hdr;
 	struct ksmbd_file *fp;
 
@@ -634,7 +634,7 @@ static void __smb2_oplock_break_noti(struct work_struct *wk)
 		return;
 	}
 
-	rsp_hdr = RESPONSE_BUF(work);
+	rsp_hdr = work->response_buf;
 	memset(rsp_hdr, 0, sizeof(struct smb2_hdr) + 2);
 	rsp_hdr->smb2_buf_length = cpu_to_be32(HEADER_SIZE_NO_BUF_LEN(conn));
 	rsp_hdr->ProtocolId = SMB2_PROTO_NUMBER;
@@ -650,7 +650,7 @@ static void __smb2_oplock_break_noti(struct work_struct *wk)
 	memset(rsp_hdr->Signature, 0, 16);
 
 
-	rsp = RESPONSE_BUF(work);
+	rsp = work->response_buf;
 
 	rsp->StructureSize = cpu_to_le16(24);
 	if (!br_info->open_trunc &&
@@ -730,7 +730,7 @@ static void __smb2_lease_break_noti(struct work_struct *wk)
 {
 	struct smb2_lease_break *rsp = NULL;
 	struct ksmbd_work *work = container_of(wk, struct ksmbd_work, work);
-	struct lease_break_info *br_info = REQUEST_BUF(work);
+	struct lease_break_info *br_info = work->request_buf;
 	struct ksmbd_conn *conn = work->conn;
 	struct smb2_hdr *rsp_hdr;
 
@@ -741,7 +741,7 @@ static void __smb2_lease_break_noti(struct work_struct *wk)
 		return;
 	}
 
-	rsp_hdr = RESPONSE_BUF(work);
+	rsp_hdr = work->response_buf;
 	memset(rsp_hdr, 0, sizeof(struct smb2_hdr) + 2);
 	rsp_hdr->smb2_buf_length = cpu_to_be32(HEADER_SIZE_NO_BUF_LEN(conn));
 	rsp_hdr->ProtocolId = SMB2_PROTO_NUMBER;
@@ -756,7 +756,7 @@ static void __smb2_lease_break_noti(struct work_struct *wk)
 	rsp_hdr->SessionId = 0;
 	memset(rsp_hdr->Signature, 0, 16);
 
-	rsp = RESPONSE_BUF(work);
+	rsp = work->response_buf;
 	rsp->StructureSize = cpu_to_le16(44);
 	rsp->Reserved = 0;
 	rsp->Flags = 0;
diff --git a/fs/cifsd/server.c b/fs/cifsd/server.c
index 048bbc66aa60..80f5229da3ac 100644
--- a/fs/cifsd/server.c
+++ b/fs/cifsd/server.c
@@ -95,7 +95,7 @@ static inline int check_conn_state(struct ksmbd_work *work)
 	struct smb_hdr *rsp_hdr;
 
 	if (ksmbd_conn_exiting(work) || ksmbd_conn_need_reconnect(work)) {
-		rsp_hdr = RESPONSE_BUF(work);
+		rsp_hdr = work->response_buf;
 		rsp_hdr->Status.CifsError = STATUS_CONNECTION_DISCONNECTED;
 		return 1;
 	}
@@ -169,7 +169,7 @@ static void __handle_ksmbd_work(struct ksmbd_work *work,
 		return;
 
 	if (conn->ops->is_transform_hdr &&
-		conn->ops->is_transform_hdr(REQUEST_BUF(work))) {
+		conn->ops->is_transform_hdr(work->request_buf)) {
 		rc = conn->ops->decrypt_req(work);
 		if (rc < 0) {
 			conn->ops->set_rsp_status(work, STATUS_DATA_ERROR);
diff --git a/fs/cifsd/smb2misc.c b/fs/cifsd/smb2misc.c
index 485f431c776c..e6b87d9d33ed 100644
--- a/fs/cifsd/smb2misc.c
+++ b/fs/cifsd/smb2misc.c
@@ -355,7 +355,7 @@ static int smb2_validate_credit_charge(struct smb2_hdr *hdr)
 
 int ksmbd_smb2_check_message(struct ksmbd_work *work)
 {
-	struct smb2_pdu *pdu = REQUEST_BUF(work);
+	struct smb2_pdu *pdu = work->request_buf;
 	struct smb2_hdr *hdr = &pdu->hdr;
 	int command;
 	__u32 clc_len;  /* calculated length */
